// --- Generated by AidaCxxStub ---
#ifndef __CLNT__BSE_IDL
#define __CLNT__BSE_IDL


// --- ClientHH Boilerplate ---
#include <rapicorn-core.hh>

#define RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ(Enum)   \
  bool constexpr operator== (Enum v, int64_t n) { return int64_t (v) == n; } \
  bool constexpr operator== (int64_t n, Enum v) { return n == int64_t (v); } \
  bool constexpr operator!= (Enum v, int64_t n) { return int64_t (v) != n; } \
  bool constexpr operator!= (int64_t n, Enum v) { return n != int64_t (v); }
#define RAPICORN_AIDA_FLAGS_DEFINE_ARITHMETIC_OPS(Enum)   \
  static constexpr int64_t operator>> (Enum v, int64_t n) { return int64_t (v) >> n; } \
  static constexpr int64_t operator<< (Enum v, int64_t n) { return int64_t (v) << n; } \
  static constexpr int64_t operator^  (Enum v, int64_t n) { return int64_t (v) ^ n; } \
  static constexpr int64_t operator^  (int64_t n, Enum v) { return n ^ int64_t (v); } \
  static constexpr int64_t operator|  (Enum v, int64_t n) { return int64_t (v) | n; } \
  static constexpr int64_t operator|  (int64_t n, Enum v) { return n | int64_t (v); } \
  static constexpr int64_t operator&  (Enum v, int64_t n) { return int64_t (v) & n; } \
  static constexpr int64_t operator&  (int64_t n, Enum v) { return n & int64_t (v); } \
  static constexpr int64_t operator~  (Enum v)            { return ~int64_t (v); } \
  static constexpr int64_t operator+  (Enum v)            { return +int64_t (v); } \
  static constexpr int64_t operator-  (Enum v)            { return -int64_t (v); } \
  static constexpr int64_t operator+  (Enum v, int64_t n) { return int64_t (v) + n; } \
  static constexpr int64_t operator+  (int64_t n, Enum v) { return n + int64_t (v); } \
  static constexpr int64_t operator-  (Enum v, int64_t n) { return int64_t (v) - n; } \
  static constexpr int64_t operator-  (int64_t n, Enum v) { return n - int64_t (v); } \
  static constexpr int64_t operator*  (Enum v, int64_t n) { return int64_t (v) * n; } \
  static constexpr int64_t operator*  (int64_t n, Enum v) { return n * int64_t (v); } \
  static constexpr int64_t operator/  (Enum v, int64_t n) { return int64_t (v) / n; } \
  static constexpr int64_t operator/  (int64_t n, Enum v) { return n / int64_t (v); } \
  static constexpr int64_t operator%  (Enum v, int64_t n) { return int64_t (v) % n; } \
  static constexpr int64_t operator%  (int64_t n, Enum v) { return n % int64_t (v); } \
  RAPICORN_FIXCYTHON_ENUM (Enum)
#ifdef     CYTHON_COMPILING_IN_CPYTHON
// Use C++ ADL, so PyInt_FromLong as generated by Cython works on scoped enums.
#define RAPICORN_FIXCYTHON_ENUM(Enum) \
  extern inline PyObject* PyInt_FromLong (Enum __e_) { return ::PyInt_FromLong (long (__e_)); }
#else  // !CYTHON_COMPILING_IN_CPYTHON
#define RAPICORN_FIXCYTHON_ENUM(Enum)
#endif // !CYTHON_COMPILING_IN_CPYTHON
#ifdef     RAPICORN_AIDA_ENABLE_ENUM_ARITHMETIC
#define RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS        RAPICORN_AIDA_FLAGS_DEFINE_ARITHMETIC_OPS
#else  // !RAPICORN_AIDA_ENABLE_ENUM_ARITHMETIC
#define RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS(Enum)  /* no arithmetic ops */
#endif // !RAPICORN_AIDA_ENABLE_ENUM_ARITHMETIC

#ifndef __ENUMHH__BSE_IDL__
#define __ENUMHH__BSE_IDL__

namespace Bse {

/// @cond GeneratedEnums
enum class Error : int64_t {
  NONE = 0, // _("OK")
  INTERNAL = 1, // _("Internal error (please report)")
  UNKNOWN = 2, // _("Unknown error")
  IO = 3, // _("Input/output error")
  PERMS = 4, // _("Insufficient permissions")
  FILE_BUSY = 5, // _("Device or resource busy")
  FILE_EXISTS = 6, // _("File exists already")
  FILE_EOF = 7, // _("End of file")
  FILE_EMPTY = 8, // _("File empty")
  FILE_NOT_FOUND = 9, // _("No such file, device or directory")
  FILE_IS_DIR = 10, // _("Is a directory")
  FILE_OPEN_FAILED = 11, // _("Open failed")
  FILE_SEEK_FAILED = 12, // _("Seek failed")
  FILE_READ_FAILED = 13, // _("Read failed")
  FILE_WRITE_FAILED = 14, // _("Write failed")
  MANY_FILES = 15, // _("Too many open files")
  NO_FILES = 16, // _("Too many open files in system")
  NO_SPACE = 17, // _("No space left on device")
  NO_MEMORY = 18, // _("Out of memory")
  NO_HEADER = 19, // _("Failed to detect header")
  NO_SEEK_INFO = 20, // _("Failed to retrieve seek information")
  NO_DATA = 21, // _("No data available")
  DATA_CORRUPT = 22, // _("Data corrupt")
  WRONG_N_CHANNELS = 23, // _("Wrong number of channels")
  FORMAT_INVALID = 24, // _("Invalid format")
  FORMAT_UNKNOWN = 25, // _("Unknown format")
  DATA_UNMATCHED = 26, // _("Requested data values unmatched")
  TEMP = 27, // _("Temporary error")
  WAVE_NOT_FOUND = 28, // _("No such wave")
  CODEC_FAILURE = 29, // _("Codec failure")
  UNIMPLEMENTED = 30, // _("Functionality not implemented")
  INVALID_PROPERTY = 31, // _("Invalid object property")
  INVALID_MIDI_CONTROL = 32, // _("Invalid MIDI control type")
  PARSE_ERROR = 33, // _("Parsing error")
  SPAWN = 34, // _("Failed to spawn child process")
  DEVICE_NOT_AVAILABLE = 35, // _("No device (driver) available")
  DEVICE_ASYNC = 36, // _("Device not async capable")
  DEVICE_BUSY = 37, // _("Device busy")
  DEVICE_FORMAT = 38, // _("Failed to configure device format")
  DEVICE_BUFFER = 39, // _("Failed to configure device buffer")
  DEVICE_LATENCY = 40, // _("Failed to configure device latency")
  DEVICE_CHANNELS = 41, // _("Failed to configure number of device channels")
  DEVICE_FREQUENCY = 42, // _("Failed to configure device frequency")
  DEVICES_MISMATCH = 43, // _("Device configurations mismatch")
  SOURCE_NO_SUCH_MODULE = 44, // _("No such synthesis module")
  SOURCE_NO_SUCH_ICHANNEL = 45, // _("No such input channel")
  SOURCE_NO_SUCH_OCHANNEL = 46, // _("No such output channel")
  SOURCE_NO_SUCH_CONNECTION = 47, // _("Input/Output channels not connected")
  SOURCE_PRIVATE_ICHANNEL = 48, // _("Input channel is private")
  SOURCE_ICHANNEL_IN_USE = 49, // _("Input channel already in use")
  SOURCE_CHANNELS_CONNECTED = 50, // _("Input/output channels already connected")
  SOURCE_CONNECTION_INVALID = 51, // _("Invalid synthesis module connection")
  SOURCE_PARENT_MISMATCH = 52, // _("Parent mismatch")
  SOURCE_BAD_LOOPBACK = 53, // _("Bad loopback")
  SOURCE_BUSY = 54, // _("Synthesis module currently busy")
  SOURCE_TYPE_INVALID = 55, // _("Invalid synthsis module type")
  PROC_NOT_FOUND = 56, // _("No such procedure")
  PROC_BUSY = 57, // _("Procedure currently busy")
  PROC_PARAM_INVAL = 58, // _("Procedure parameter invalid")
  PROC_EXECUTION = 59, // _("Procedure execution failed")
  PROC_ABORT = 60, // _("Procedure execution aborted")
  NO_ENTRY = 61, // _("No such entry")
  NO_EVENT = 62, // _("No such event")
  NO_TARGET = 63, // _("No target")
  NOT_OWNER = 64, // _("Ownership mismatch")
  INVALID_OFFSET = 65, // _("Invalid offset")
  INVALID_DURATION = 66, // _("Invalid duration")
  INVALID_OVERLAP = 67, // _("Invalid overlap")
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  Error  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, Error &e) { e = Error (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (Error);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (Error);
/// @endcond

/// @cond GeneratedEnums
enum class MidiSignal : int64_t {
  PROGRAM = 1,
  PRESSURE = 2,
  PITCH_BEND = 3,
  VELOCITY = 4,
  FINE_TUNE = 5,
  CONTINUOUS_0 = 64,
  CONTINUOUS_1 = 65,
  CONTINUOUS_2 = 66,
  CONTINUOUS_3 = 67,
  CONTINUOUS_4 = 68,
  CONTINUOUS_5 = 69,
  CONTINUOUS_6 = 70,
  CONTINUOUS_7 = 71,
  CONTINUOUS_8 = 72,
  CONTINUOUS_9 = 73,
  CONTINUOUS_10 = 74,
  CONTINUOUS_11 = 75,
  CONTINUOUS_12 = 76,
  CONTINUOUS_13 = 77,
  CONTINUOUS_14 = 78,
  CONTINUOUS_15 = 79,
  CONTINUOUS_16 = 80,
  CONTINUOUS_17 = 81,
  CONTINUOUS_18 = 82,
  CONTINUOUS_19 = 83,
  CONTINUOUS_20 = 84,
  CONTINUOUS_21 = 85,
  CONTINUOUS_22 = 86,
  CONTINUOUS_23 = 87,
  CONTINUOUS_24 = 88,
  CONTINUOUS_25 = 89,
  CONTINUOUS_26 = 90,
  CONTINUOUS_27 = 91,
  CONTINUOUS_28 = 92,
  CONTINUOUS_29 = 93,
  CONTINUOUS_30 = 94,
  CONTINUOUS_31 = 95,
  CONSTANT_HIGH = 96,
  CONSTANT_CENTER = 97,
  CONSTANT_LOW = 98,
  CONSTANT_NEGATIVE_CENTER = 99,
  CONSTANT_NEGATIVE_HIGH = 100,
  PARAMETER = 101,
  NON_PARAMETER = 102,
  CONTROL_0 = 128,
  CONTROL_1 = 129,
  CONTROL_2 = 130,
  CONTROL_3 = 131,
  CONTROL_4 = 132,
  CONTROL_5 = 133,
  CONTROL_6 = 134,
  CONTROL_7 = 135,
  CONTROL_8 = 136,
  CONTROL_9 = 137,
  CONTROL_10 = 138,
  CONTROL_11 = 139,
  CONTROL_12 = 140,
  CONTROL_13 = 141,
  CONTROL_14 = 142,
  CONTROL_15 = 143,
  CONTROL_16 = 144,
  CONTROL_17 = 145,
  CONTROL_18 = 146,
  CONTROL_19 = 147,
  CONTROL_20 = 148,
  CONTROL_21 = 149,
  CONTROL_22 = 150,
  CONTROL_23 = 151,
  CONTROL_24 = 152,
  CONTROL_25 = 153,
  CONTROL_26 = 154,
  CONTROL_27 = 155,
  CONTROL_28 = 156,
  CONTROL_29 = 157,
  CONTROL_30 = 158,
  CONTROL_31 = 159,
  CONTROL_32 = 160,
  CONTROL_33 = 161,
  CONTROL_34 = 162,
  CONTROL_35 = 163,
  CONTROL_36 = 164,
  CONTROL_37 = 165,
  CONTROL_38 = 166,
  CONTROL_39 = 167,
  CONTROL_40 = 168,
  CONTROL_41 = 169,
  CONTROL_42 = 170,
  CONTROL_43 = 171,
  CONTROL_44 = 172,
  CONTROL_45 = 173,
  CONTROL_46 = 174,
  CONTROL_47 = 175,
  CONTROL_48 = 176,
  CONTROL_49 = 177,
  CONTROL_50 = 178,
  CONTROL_51 = 179,
  CONTROL_52 = 180,
  CONTROL_53 = 181,
  CONTROL_54 = 182,
  CONTROL_55 = 183,
  CONTROL_56 = 184,
  CONTROL_57 = 185,
  CONTROL_58 = 186,
  CONTROL_59 = 187,
  CONTROL_60 = 188,
  CONTROL_61 = 189,
  CONTROL_62 = 190,
  CONTROL_63 = 191,
  CONTROL_64 = 192,
  CONTROL_65 = 193,
  CONTROL_66 = 194,
  CONTROL_67 = 195,
  CONTROL_68 = 196,
  CONTROL_69 = 197,
  CONTROL_70 = 198,
  CONTROL_71 = 199,
  CONTROL_72 = 200,
  CONTROL_73 = 201,
  CONTROL_74 = 202,
  CONTROL_75 = 203,
  CONTROL_76 = 204,
  CONTROL_77 = 205,
  CONTROL_78 = 206,
  CONTROL_79 = 207,
  CONTROL_80 = 208,
  CONTROL_81 = 209,
  CONTROL_82 = 210,
  CONTROL_83 = 211,
  CONTROL_84 = 212,
  CONTROL_85 = 213,
  CONTROL_86 = 214,
  CONTROL_87 = 215,
  CONTROL_88 = 216,
  CONTROL_89 = 217,
  CONTROL_90 = 218,
  CONTROL_91 = 219,
  CONTROL_92 = 220,
  CONTROL_93 = 221,
  CONTROL_94 = 222,
  CONTROL_95 = 223,
  CONTROL_96 = 224,
  CONTROL_97 = 225,
  CONTROL_98 = 226,
  CONTROL_99 = 227,
  CONTROL_100 = 228,
  CONTROL_101 = 229,
  CONTROL_102 = 230,
  CONTROL_103 = 231,
  CONTROL_104 = 232,
  CONTROL_105 = 233,
  CONTROL_106 = 234,
  CONTROL_107 = 235,
  CONTROL_108 = 236,
  CONTROL_109 = 237,
  CONTROL_110 = 238,
  CONTROL_111 = 239,
  CONTROL_112 = 240,
  CONTROL_113 = 241,
  CONTROL_114 = 242,
  CONTROL_115 = 243,
  CONTROL_116 = 244,
  CONTROL_117 = 245,
  CONTROL_118 = 246,
  CONTROL_119 = 247,
  CONTROL_120 = 248,
  CONTROL_121 = 249,
  CONTROL_122 = 250,
  CONTROL_123 = 251,
  CONTROL_124 = 252,
  CONTROL_125 = 253,
  CONTROL_126 = 254,
  CONTROL_127 = 255,
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  MidiSignal  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, MidiSignal &e) { e = MidiSignal (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (MidiSignal);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (MidiSignal);
/// @endcond

/// @cond GeneratedEnums
enum class MusicalTuning : int64_t {
  OD_12_TET = 1, // _("The most common tuning system for modern Western music, is the twelve-tone equal temperament, abbreviated as 12-TET, which divides the octave into 12 equal parts.")
  OD_7_TET = 2, // _("A fairly common tuning system is the seven-tone equal temperament tuning system, abbreviated as 7-TET. It divides the octave into 7 equal parts using 171 cent steps.")
  OD_5_TET = 3, // _("A fairly common tuning system is the five-tone equal temperament tuning system, abbreviated as 5-TET. It divides the octave into 5 equal parts using 240 cent steps.")
  DIATONIC_SCALE = 4, // _("In music theory, a diatonic scale (also: heptatonia prima) is a seven-note musical scale comprising five whole-tone and two half-tone steps. The half tones are maximally separated, so between two half-tone steps there are either two or three whole tones, repeating per octave.")
  INDIAN_SCALE = 5, // _("Diatonic scale used in Indian music with wolf interval at Dha, close to 3/2")
  PYTHAGOREAN_TUNING = 6, // _("Pythagorean tuning is the oldest way of tuning the 12-note chromatic scale, in which the frequency relationships of all intervals are based on the ratio 3:2. Its discovery is generally credited to Pythagoras.")
  PENTATONIC_5_LIMIT = 7, // _("Pentatonic scales are used in modern jazz and pop/rock contexts because they work exceedingly well over several chords diatonic to the same key, often better than the parent scale.")
  PENTATONIC_BLUES = 8, // _("The blues scale is the minor pentatonic with an additional augmented fourth, which is referred to as the \"blues note\".")
  PENTATONIC_GOGO = 9, // _("The Pentatonic Gogo scale is an anhemitonic pentatonic scale used to tune the instruments of the Gogo people of Tanzania.")
  QUARTER_COMMA_MEANTONE = 10, // _("Quarter-comma meantone was the most common meantone temperament in the sixteenth and seventeenth centuries and sometimes used later.")
  SILBERMANN_SORGE = 11, // _("The Silbermann-Sorge temperament is a meantone temperament used for Baroque era organs by Gottfried Silbermann.")
  WERCKMEISTER_3 = 12, // _("This tuning uses mostly pure (perfect) fifths, as in Pythagorean tuning, but each of the fifths C-G, G-D, D-A and B-F# is made smaller, i.e. tempered by 1/4 comma. Werckmeister designated this tuning as particularly suited for playing chromatic music.")
  WERCKMEISTER_4 = 13, // _("In this tuning the fifths C-G, D-A, E-B, F#-C#, and Bb-F are tempered narrow by 1/3 comma, and the fifths G#-D# and Eb-Bb are widened by 1/3 comma. The other fifths are pure. Most of its intervals are close to sixth-comma meantone. Werckmeister designed this tuning for playing mainly diatonic music.")
  WERCKMEISTER_5 = 14, // _("In this tuning the fifths D-A, A-E, F#-C#, C#-G#, and F-C are narrowed by 1/4 comma, and the fifth G#-D# is widened by 1/4 comma. The other fifths are pure. This temperament is closer to equal temperament than Werckmeister III or IV.")
  WERCKMEISTER_6 = 15, // _("This tuning is also known as Septenarius tuning is based on a division of the monochord length into 196 = 7 * 7 * 4 parts. The resulting scale has rational frequency relationships, but in practice involves pure and impure sounding fifths. Werckmeister described the Septenarius as a \"temperament which has nothing at all to do with the divisions of the comma, nevertheless in practice so correct that one can be really satisfied with it\".")
  KIRNBERGER_3 = 16, // _("Kirnberger's method of compensating for and closing the circle of fifths is to split the \"wolf\" interval known to those who have used meantone temperaments between four fifths instead, allowing for four 1/4-comma wolves to take their place. 1/4-comma wolves are used extensively in meantone and are much easier to tune and to listen to. Therefore, only one third remains pure (between C and E).")
  YOUNG = 17, // _("Thomas Young devised a form of musical tuning to make the harmony most perfect in those keys which are the most frequently used (give better major thirds in those keys), but to not have any unplayable keys. This is attempted by tuning upwards from C a sequence of six pure fourths, as well as six equally imperfect fifths.")
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  MusicalTuning  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, MusicalTuning &e) { e = MusicalTuning (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (MusicalTuning);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (MusicalTuning);
/// @endcond

/// @cond GeneratedEnums
enum class UserMessageType : int64_t {
  ERROR = 1,
  WARNING = 2,
  INFO = 3,
  DEBUG = 4,
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  UserMessageType  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, UserMessageType &e) { e = UserMessageType (__f_.pop_evalue()); }
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_EQ (UserMessageType);
RAPICORN_AIDA_ENUM_DEFINE_ARITHMETIC_OPS (UserMessageType);
/// @endcond
} // Bse

namespace Rapicorn {

namespace Aida {
template<> const EnumInfo& enum_info<Bse::Error> ();
template<> const EnumInfo& enum_info<Bse::MidiSignal> ();
template<> const EnumInfo& enum_info<Bse::MusicalTuning> ();
template<> const EnumInfo& enum_info<Bse::UserMessageType> ();
} // Aida
} // Rapicorn

#endif // __ENUMHH__BSE_IDL__


// --- Interfaces (class declarations) ---

namespace Bse {

struct ClnT_StringSeq : public std::vector<std::string>
{
  typedef std::vector<std::string> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::StringSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_StringSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_StringSeq&);

struct ClnT_PixelSeq : public std::vector<int>
{
  typedef std::vector<int> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PixelSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PixelSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PixelSeq&);

struct ClnT_Icon
{
  /// @cond GeneratedFields
  int                           width;
  int                           height;
  ClnT_PixelSeq                 pixels;
  /// @endcond
  inline                        ClnT_Icon () { width = 0; height = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::Icon"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_Icon &other) const;
  bool                          operator!=  (const ClnT_Icon &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (width, "width");
    _visitor_ (height, "height");
    _visitor_ (pixels, "pixels");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_Icon&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_Icon&);

struct ClnT_AuxData
{
  /// @cond GeneratedFields
  std::string                   entity;
  ClnT_StringSeq                attributes;
  /// @endcond
  inline                        ClnT_AuxData () { }
  std::string                   __aida_type_name__ () const	{ return "Bse::AuxData"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_AuxData &other) const;
  bool                          operator!=  (const ClnT_AuxData &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (entity, "entity");
    _visitor_ (attributes, "attributes");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_AuxData&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_AuxData&);

struct ClnT_AuxDataSeq : public std::vector<ClnT_AuxData>
{
  typedef std::vector<ClnT_AuxData> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::AuxDataSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_AuxDataSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_AuxDataSeq&);

/** @interface TestObject
 * See also the corresponding C++ stub class TestObjectHandle. */
/// See also the corresponding IDL class TestObject.
class TestObjectHandle : public virtual Rapicorn::Aida::RemoteHandle
{
  typedef Rapicorn::Aida::Connector<TestObjectHandle, void (const std::string &msg)> __Aida_Signal__echo_reply;
  size_t __aida_connect__echo_reply (size_t, const std::function<void (const std::string &msg)>&);
  static TestObjectHandle                __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~TestObjectHandle () override;
  template<class RemoteHandle>
  static TestObjectHandle       down_cast (RemoteHandle smh) { return smh == NULL ? TestObjectHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      TestObjectHandle ();
  __Aida_Signal__echo_reply     sig_echo_reply () { return __Aida_Signal__echo_reply (*this, &TestObjectHandle::__aida_connect__echo_reply); }
  int                           echo_test        (const std::string &msg); 	///< See TestObject::echo_test()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {}
};
typedef TestObjectHandle TestObjectH; ///< Convenience alias for the IDL type TestObject.

struct ClnT_UserMessage
{
  /// @cond GeneratedFields
  UserMessageType               utype;
  std::string                   title;
  std::string                   text1;
  std::string                   text2;
  std::string                   text3;
  std::string                   label;
  /// @endcond
  inline                        ClnT_UserMessage () { utype = UserMessageType (0); }
  std::string                   __aida_type_name__ () const	{ return "Bse::UserMessage"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_UserMessage &other) const;
  bool                          operator!=  (const ClnT_UserMessage &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (utype, "utype");
    _visitor_ (title, "title");
    _visitor_ (text1, "text1");
    _visitor_ (text2, "text2");
    _visitor_ (text3, "text3");
    _visitor_ (label, "label");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_UserMessage&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_UserMessage&);

struct ClnT_SongTiming
{
  /// @cond GeneratedFields
  int                           tick;
  double                        bpm;
  int                           numerator;
  int                           denominator;
  int                           tpqn;
  int                           tpt;
  double                        stamp_ticks;
  /// @endcond
  inline                        ClnT_SongTiming () { tick = 0; bpm = 0; numerator = 0; denominator = 0; tpqn = 0; tpt = 0; stamp_ticks = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::SongTiming"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_SongTiming &other) const;
  bool                          operator!=  (const ClnT_SongTiming &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (tick, "tick");
    _visitor_ (bpm, "bpm");
    _visitor_ (numerator, "numerator");
    _visitor_ (denominator, "denominator");
    _visitor_ (tpqn, "tpqn");
    _visitor_ (tpt, "tpt");
    _visitor_ (stamp_ticks, "stamp_ticks");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_SongTiming&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_SongTiming&);

struct ClnT_NoteDescription
{
  /// @cond GeneratedFields
  MusicalTuning                 musical_tuning;
  int                           note;
  int                           octave;
  double                        freq;
  int                           finetune;
  int                           semitone;
  bool                          upshift;
  int                           letter;
  std::string                   name;
  /// @endcond
  inline                        ClnT_NoteDescription () { musical_tuning = MusicalTuning (0); note = 0; octave = 0; freq = 0; finetune = 0; semitone = 0; upshift = 0; letter = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::NoteDescription"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_NoteDescription &other) const;
  bool                          operator!=  (const ClnT_NoteDescription &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (musical_tuning, "musical_tuning");
    _visitor_ (note, "note");
    _visitor_ (octave, "octave");
    _visitor_ (freq, "freq");
    _visitor_ (finetune, "finetune");
    _visitor_ (semitone, "semitone");
    _visitor_ (upshift, "upshift");
    _visitor_ (letter, "letter");
    _visitor_ (name, "name");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_NoteDescription&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_NoteDescription&);

class ClnT_PartLink;

class ClnT_PartLinkSeq;

class ClnT_TrackPart;

class ClnT_TrackPartSeq;

/** @interface Object
 * See also the corresponding C++ stub class ObjectHandle. */
/// See also the corresponding IDL class Object.
class ObjectHandle : public virtual Rapicorn::Aida::RemoteHandle
{
  typedef Rapicorn::Aida::Connector<ObjectHandle, void (const std::string &what)> __Aida_Signal__changed;
  size_t __aida_connect__changed (size_t, const std::function<void (const std::string &what)>&);
  static ObjectHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ObjectHandle () override;
  template<class RemoteHandle>
  static ObjectHandle           down_cast (RemoteHandle smh) { return smh == NULL ? ObjectHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ObjectHandle ();
  __Aida_Signal__changed        sig_changed () { return __Aida_Signal__changed (*this, &ObjectHandle::__aida_connect__changed); }
  std::string                   debug_name   (); 	///< See Object::debug_name()
  int64_t                       proxy_id     (); 	///< See Object::proxy_id()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {}
};
typedef ObjectHandle ObjectH; ///< Convenience alias for the IDL type Object.

/** @interface Item
 * See also the corresponding C++ stub class ItemHandle. */
/// See also the corresponding IDL class Item.
class ItemHandle : public virtual ObjectHandle
{
  static ItemHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ItemHandle () override;
  template<class RemoteHandle>
  static ItemHandle             down_cast (RemoteHandle smh) { return smh == NULL ? ItemHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ItemHandle ();
  ClnT_Icon                     icon () const; 	///< See Item::icon
  void                          icon (const ClnT_Icon&); 	///< See Item::icon
  ItemHandle                    common_ancestor (ItemHandle &other); 	///< See Item::common_ancestor()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "icon", &ItemHandle::icon, &ItemHandle::icon);
    this->ObjectHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ItemHandle ItemH; ///< Convenience alias for the IDL type Item.

struct ClnT_PartNote
{
  /// @cond GeneratedFields
  int                           id;
  int                           channel;
  int                           tick;
  int                           duration;
  int                           note;
  int                           fine_tune;
  double                        velocity;
  bool                          selected;
  /// @endcond
  inline                        ClnT_PartNote () { id = 0; channel = 0; tick = 0; duration = 0; note = 0; fine_tune = 0; velocity = 0; selected = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartNote"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_PartNote &other) const;
  bool                          operator!=  (const ClnT_PartNote &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (id, "id");
    _visitor_ (channel, "channel");
    _visitor_ (tick, "tick");
    _visitor_ (duration, "duration");
    _visitor_ (note, "note");
    _visitor_ (fine_tune, "fine_tune");
    _visitor_ (velocity, "velocity");
    _visitor_ (selected, "selected");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartNote&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartNote&);

struct ClnT_PartNoteSeq : public std::vector<ClnT_PartNote>
{
  typedef std::vector<ClnT_PartNote> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartNoteSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartNoteSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartNoteSeq&);

struct ClnT_PartControl
{
  /// @cond GeneratedFields
  int                           id;
  int                           tick;
  MidiSignal                    control_type;
  double                        value;
  bool                          selected;
  /// @endcond
  inline                        ClnT_PartControl () { id = 0; tick = 0; control_type = MidiSignal (0); value = 0; selected = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartControl"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_PartControl &other) const;
  bool                          operator!=  (const ClnT_PartControl &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (id, "id");
    _visitor_ (tick, "tick");
    _visitor_ (control_type, "control_type");
    _visitor_ (value, "value");
    _visitor_ (selected, "selected");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartControl&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartControl&);

struct ClnT_PartControlSeq : public std::vector<ClnT_PartControl>
{
  typedef std::vector<ClnT_PartControl> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartControlSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartControlSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartControlSeq&);

/** @interface Part
 * See also the corresponding C++ stub class PartHandle. */
/// See also the corresponding IDL class Part.
class PartHandle : public virtual ItemHandle
{
  static PartHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~PartHandle () override;
  template<class RemoteHandle>
  static PartHandle             down_cast (RemoteHandle smh) { return smh == NULL ? PartHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      PartHandle ();
  ClnT_PartControlSeq           list_selected_controls    (MidiSignal control_type); 	///< See Part::list_selected_controls()
  ClnT_PartControlSeq           list_controls             (int tick,
                                                           int duration,
                                                           MidiSignal control_type); 	///< See Part::list_controls()
  ClnT_PartControlSeq           get_channel_controls      (int channel,
                                                           int tick,
                                                           int duration,
                                                           MidiSignal control_type); 	///< See Part::get_channel_controls()
  ClnT_PartControlSeq           get_controls              (int tick,
                                                           MidiSignal control_type); 	///< See Part::get_controls()
  ClnT_SongTiming               get_timing                (int tick); 	///< See Part::get_timing()
  int                           get_max_note              (); 	///< See Part::get_max_note()
  int                           get_min_note              (); 	///< See Part::get_min_note()
  Error                         change_control            (int id,
                                                           int tick,
                                                           MidiSignal control_type,
                                                           double value); 	///< See Part::change_control()
  Error                         change_note               (int id,
                                                           int tick,
                                                           int duration,
                                                           int note,
                                                           int fine_tune,
                                                           double velocity); 	///< See Part::change_note()
  Error                         delete_event              (int id); 	///< See Part::delete_event()
  int                           insert_control            (int tick,
                                                           MidiSignal control_type,
                                                           double value); 	///< See Part::insert_control()
  int                           insert_note               (int channel,
                                                           int tick,
                                                           int duration,
                                                           int note,
                                                           int fine_tune,
                                                           double velocity); 	///< See Part::insert_note()
  int                           insert_note_auto          (int tick,
                                                           int duration,
                                                           int note,
                                                           int fine_tune,
                                                           double velocity); 	///< See Part::insert_note_auto()
  bool                          is_event_selected         (int id); 	///< See Part::is_event_selected()
  void                          queue_controls            (int tick,
                                                           int duration); 	///< See Part::queue_controls()
  void                          queue_notes               (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::queue_notes()
  void                          select_notes_exclusive    (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::select_notes_exclusive()
  void                          select_controls_exclusive (int tick,
                                                           int duration,
                                                           MidiSignal control_type); 	///< See Part::select_controls_exclusive()
  void                          select_notes              (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::select_notes()
  void                          select_event              (int id); 	///< See Part::select_event()
  void                          select_controls           (int tick,
                                                           int duration,
                                                           MidiSignal control_type); 	///< See Part::select_controls()
  void                          deselect_notes            (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::deselect_notes()
  void                          deselect_event            (int id); 	///< See Part::deselect_event()
  void                          deselect_controls         (int tick,
                                                           int duration,
                                                           MidiSignal control_type); 	///< See Part::deselect_controls()
  ClnT_PartNoteSeq              list_notes_crossing       (int tick,
                                                           int duration); 	///< See Part::list_notes_crossing()
  ClnT_PartNoteSeq              list_notes_within         (int channel,
                                                           int tick,
                                                           int duration); 	///< See Part::list_notes_within()
  ClnT_PartNoteSeq              list_selected_notes       (); 	///< See Part::list_selected_notes()
  ClnT_PartNoteSeq              check_overlap             (int tick,
                                                           int duration,
                                                           int note); 	///< See Part::check_overlap()
  ClnT_PartNoteSeq              get_notes                 (int tick,
                                                           int note); 	///< See Part::get_notes()
  ClnT_PartLinkSeq              list_links                (); 	///< See Part::list_links()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef PartHandle PartH; ///< Convenience alias for the IDL type Part.

struct ClnT_PartSeq : public std::vector<Rapicorn::Aida::RemoteMember<PartHandle>>
{
  typedef std::vector<Rapicorn::Aida::RemoteMember<PartHandle>> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartSeq&);

/** @interface Source
 * See also the corresponding C++ stub class SourceHandle. */
/// See also the corresponding IDL class Source.
class SourceHandle : public virtual ItemHandle
{
  static SourceHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SourceHandle () override;
  template<class RemoteHandle>
  static SourceHandle           down_cast (RemoteHandle smh) { return smh == NULL ? SourceHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SourceHandle ();
  SourceHandle                  ichannel_get_osource (int input_channel,
                                                      int input_joint); 	///< See Source::ichannel_get_osource()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SourceHandle SourceH; ///< Convenience alias for the IDL type Source.

/** @interface ContextMerger
 * See also the corresponding C++ stub class ContextMergerHandle. */
/// See also the corresponding IDL class ContextMerger.
class ContextMergerHandle : public virtual SourceHandle
{
  static ContextMergerHandle             __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ContextMergerHandle () override;
  template<class RemoteHandle>
  static ContextMergerHandle    down_cast (RemoteHandle smh) { return smh == NULL ? ContextMergerHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ContextMergerHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ContextMergerHandle ContextMergerH; ///< Convenience alias for the IDL type ContextMerger.

/** @interface Container
 * See also the corresponding C++ stub class ContainerHandle. */
/// See also the corresponding IDL class Container.
class ContainerHandle : public virtual SourceHandle
{
  static ContainerHandle                 __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ContainerHandle () override;
  template<class RemoteHandle>
  static ContainerHandle        down_cast (RemoteHandle smh) { return smh == NULL ? ContainerHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ContainerHandle ();
  ItemHandle                    lookup_item     (const std::string &uname); 	///< See Container::lookup_item()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ContainerHandle ContainerH; ///< Convenience alias for the IDL type Container.

/** @interface Super
 * See also the corresponding C++ stub class SuperHandle. */
/// See also the corresponding IDL class Super.
class SuperHandle : public virtual ContainerHandle
{
  static SuperHandle                     __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SuperHandle () override;
  template<class RemoteHandle>
  static SuperHandle            down_cast (RemoteHandle smh) { return smh == NULL ? SuperHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SuperHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContainerHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SuperHandle SuperH; ///< Convenience alias for the IDL type Super.

/** @interface SNet
 * See also the corresponding C++ stub class SNetHandle. */
/// See also the corresponding IDL class SNet.
class SNetHandle : public virtual SuperHandle
{
  typedef Rapicorn::Aida::Connector<SNetHandle, void ()> __Aida_Signal__port_unregistered;
  size_t __aida_connect__port_unregistered (size_t, const std::function<void ()>&);
  static SNetHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SNetHandle () override;
  template<class RemoteHandle>
  static SNetHandle             down_cast (RemoteHandle smh) { return smh == NULL ? SNetHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SNetHandle ();
  bool                          auto_activate () const; 	///< See SNet::auto_activate
  void                          auto_activate (bool); 	///< See SNet::auto_activate
  __Aida_Signal__port_unregistered sig_port_unregistered () { return __Aida_Signal__port_unregistered (*this, &SNetHandle::__aida_connect__port_unregistered); }
  bool                          supports_user_synths (); 	///< See SNet::supports_user_synths()
  Error                         can_create_source    (const std::string &module_type); 	///< See SNet::can_create_source()
  SourceHandle                  create_source        (const std::string &module_type); 	///< See SNet::create_source()
  Error                         remove_source        (SourceHandle &module); 	///< See SNet::remove_source()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "auto_activate", &SNetHandle::auto_activate, &SNetHandle::auto_activate);
    this->SuperHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SNetHandle SNetH; ///< Convenience alias for the IDL type SNet.

/** @interface CSynth
 * See also the corresponding C++ stub class CSynthHandle. */
/// See also the corresponding IDL class CSynth.
class CSynthHandle : public virtual SNetHandle
{
  static CSynthHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~CSynthHandle () override;
  template<class RemoteHandle>
  static CSynthHandle           down_cast (RemoteHandle smh) { return smh == NULL ? CSynthHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      CSynthHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SNetHandle::__accept_accessor__ (__visitor_);
  }
};
typedef CSynthHandle CSynthH; ///< Convenience alias for the IDL type CSynth.

/** @interface SubSynth
 * See also the corresponding C++ stub class SubSynthHandle. */
/// See also the corresponding IDL class SubSynth.
class SubSynthHandle : public virtual SourceHandle
{
  static SubSynthHandle                  __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SubSynthHandle () override;
  template<class RemoteHandle>
  static SubSynthHandle         down_cast (RemoteHandle smh) { return smh == NULL ? SubSynthHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SubSynthHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SubSynthHandle SubSynthH; ///< Convenience alias for the IDL type SubSynth.

/** @interface Track
 * See also the corresponding C++ stub class TrackHandle. */
/// See also the corresponding IDL class Track.
class TrackHandle : public virtual ContextMergerHandle
{
  static TrackHandle                     __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~TrackHandle () override;
  template<class RemoteHandle>
  static TrackHandle            down_cast (RemoteHandle smh) { return smh == NULL ? TrackHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      TrackHandle ();
  ClnT_SongTiming               get_timing        (int tick); 	///< See Track::get_timing()
  int                           insert_part       (int tick,
                                                   PartHandle &part); 	///< See Track::insert_part()
  void                          remove_tick       (int tick); 	///< See Track::remove_tick()
  void                          remove_link       (int id); 	///< See Track::remove_link()
  ClnT_PartSeq                  list_parts_uniq   (); 	///< See Track::list_parts_uniq()
  ClnT_TrackPartSeq             list_parts        (); 	///< See Track::list_parts()
  PartHandle                    get_part          (int tick); 	///< See Track::get_part()
  int                           get_last_tick     (); 	///< See Track::get_last_tick()
  Error                         ensure_output     (); 	///< See Track::ensure_output()
  SourceHandle                  get_output_source (); 	///< See Track::get_output_source()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContextMergerHandle::__accept_accessor__ (__visitor_);
  }
};
typedef TrackHandle TrackH; ///< Convenience alias for the IDL type Track.

struct ClnT_PartLink
{
  /// @cond GeneratedFields
  Rapicorn::Aida::RemoteMember<TrackHandle> track;
  int                           tick;
  Rapicorn::Aida::RemoteMember<PartHandle> part;
  int                           duration;
  /// @endcond
  inline                        ClnT_PartLink () { tick = 0; duration = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartLink"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_PartLink &other) const;
  bool                          operator!=  (const ClnT_PartLink &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (track, "track");
    _visitor_ (tick, "tick");
    _visitor_ (part, "part");
    _visitor_ (duration, "duration");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartLink&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartLink&);

struct ClnT_PartLinkSeq : public std::vector<ClnT_PartLink>
{
  typedef std::vector<ClnT_PartLink> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartLinkSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartLinkSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartLinkSeq&);

struct ClnT_TrackPart
{
  /// @cond GeneratedFields
  int                           tick;
  Rapicorn::Aida::RemoteMember<PartHandle> part;
  int                           duration;
  /// @endcond
  inline                        ClnT_TrackPart () { tick = 0; duration = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::TrackPart"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_TrackPart &other) const;
  bool                          operator!=  (const ClnT_TrackPart &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (tick, "tick");
    _visitor_ (part, "part");
    _visitor_ (duration, "duration");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_TrackPart&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_TrackPart&);

struct ClnT_TrackPartSeq : public std::vector<ClnT_TrackPart>
{
  typedef std::vector<ClnT_TrackPart> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::TrackPartSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_TrackPartSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_TrackPartSeq&);

/** @interface Bus
 * See also the corresponding C++ stub class BusHandle. */
/// See also the corresponding IDL class Bus.
class BusHandle : public virtual SubSynthHandle
{
  static BusHandle                       __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~BusHandle () override;
  template<class RemoteHandle>
  static BusHandle              down_cast (RemoteHandle smh) { return smh == NULL ? BusHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      BusHandle ();
  Error                         ensure_output    (); 	///< See Bus::ensure_output()
  Error                         connect_bus      (BusHandle &bus); 	///< See Bus::connect_bus()
  Error                         connect_track    (TrackHandle &track); 	///< See Bus::connect_track()
  Error                         disconnect_bus   (BusHandle &bus); 	///< See Bus::disconnect_bus()
  Error                         disconnect_track (TrackHandle &track); 	///< See Bus::disconnect_track()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SubSynthHandle::__accept_accessor__ (__visitor_);
  }
};
typedef BusHandle BusH; ///< Convenience alias for the IDL type Bus.

/** @interface Song
 * See also the corresponding C++ stub class SongHandle. */
/// See also the corresponding IDL class Song.
class SongHandle : public virtual SNetHandle
{
  static SongHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SongHandle () override;
  template<class RemoteHandle>
  static SongHandle             down_cast (RemoteHandle smh) { return smh == NULL ? SongHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SongHandle ();
  double                        bpm            () const; 	///< See Song::bpm
  void                          bpm            (double); 	///< See Song::bpm
  MusicalTuning                 musical_tuning () const; 	///< See Song::musical_tuning
  void                          musical_tuning (MusicalTuning); 	///< See Song::musical_tuning
  ClnT_SongTiming               get_timing              (int tick); 	///< See Song::get_timing()
  TrackHandle                   find_any_track_for_part (PartHandle &part); 	///< See Song::find_any_track_for_part()
  BusHandle                     create_bus              (); 	///< See Song::create_bus()
  void                          remove_bus              (BusHandle &bus); 	///< See Song::remove_bus()
  PartHandle                    create_part             (); 	///< See Song::create_part()
  void                          remove_part             (PartHandle &part); 	///< See Song::remove_part()
  TrackHandle                   create_track            (); 	///< See Song::create_track()
  void                          remove_track            (TrackHandle &track); 	///< See Song::remove_track()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "bpm", &SongHandle::bpm, &SongHandle::bpm);
    __visitor_ (*this, "musical_tuning", &SongHandle::musical_tuning, &SongHandle::musical_tuning);
    this->SNetHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SongHandle SongH; ///< Convenience alias for the IDL type Song.

struct ClnT_SampleFileInfo
{
  /// @cond GeneratedFields
  std::string                   file;
  int64_t                       size;
  int64_t                       mtime;
  std::string                   loader;
  ClnT_StringSeq                waves;
  Error                         error;
  /// @endcond
  inline                        ClnT_SampleFileInfo () { size = 0; mtime = 0; error = Error (0); }
  std::string                   __aida_type_name__ () const	{ return "Bse::SampleFileInfo"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_SampleFileInfo &other) const;
  bool                          operator!=  (const ClnT_SampleFileInfo &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (file, "file");
    _visitor_ (size, "size");
    _visitor_ (mtime, "mtime");
    _visitor_ (loader, "loader");
    _visitor_ (waves, "waves");
    _visitor_ (error, "error");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_SampleFileInfo&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_SampleFileInfo&);

/** @interface EditableSample
 * See also the corresponding C++ stub class EditableSampleHandle. */
/// See also the corresponding IDL class EditableSample.
class EditableSampleHandle : public virtual ItemHandle
{
  static EditableSampleHandle            __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~EditableSampleHandle () override;
  template<class RemoteHandle>
  static EditableSampleHandle   down_cast (RemoteHandle smh) { return smh == NULL ? EditableSampleHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      EditableSampleHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef EditableSampleHandle EditableSampleH; ///< Convenience alias for the IDL type EditableSample.

/** @interface Wave
 * See also the corresponding C++ stub class WaveHandle. */
/// See also the corresponding IDL class Wave.
class WaveHandle : public virtual SourceHandle
{
  static WaveHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~WaveHandle () override;
  template<class RemoteHandle>
  static WaveHandle             down_cast (RemoteHandle smh) { return smh == NULL ? WaveHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      WaveHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef WaveHandle WaveH; ///< Convenience alias for the IDL type Wave.

/** @interface WaveRepo
 * See also the corresponding C++ stub class WaveRepoHandle. */
/// See also the corresponding IDL class WaveRepo.
class WaveRepoHandle : public virtual SuperHandle
{
  static WaveRepoHandle                  __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~WaveRepoHandle () override;
  template<class RemoteHandle>
  static WaveRepoHandle         down_cast (RemoteHandle smh) { return smh == NULL ? WaveRepoHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      WaveRepoHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SuperHandle::__accept_accessor__ (__visitor_);
  }
};
typedef WaveRepoHandle WaveRepoH; ///< Convenience alias for the IDL type WaveRepo.

/** @interface MidiNotifier
 * See also the corresponding C++ stub class MidiNotifierHandle. */
/// See also the corresponding IDL class MidiNotifier.
class MidiNotifierHandle : public virtual ItemHandle
{
  static MidiNotifierHandle              __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~MidiNotifierHandle () override;
  template<class RemoteHandle>
  static MidiNotifierHandle     down_cast (RemoteHandle smh) { return smh == NULL ? MidiNotifierHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      MidiNotifierHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef MidiNotifierHandle MidiNotifierH; ///< Convenience alias for the IDL type MidiNotifier.

/** @interface MidiSynth
 * See also the corresponding C++ stub class MidiSynthHandle. */
/// See also the corresponding IDL class MidiSynth.
class MidiSynthHandle : public virtual SNetHandle
{
  static MidiSynthHandle                 __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~MidiSynthHandle () override;
  template<class RemoteHandle>
  static MidiSynthHandle        down_cast (RemoteHandle smh) { return smh == NULL ? MidiSynthHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      MidiSynthHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SNetHandle::__accept_accessor__ (__visitor_);
  }
};
typedef MidiSynthHandle MidiSynthH; ///< Convenience alias for the IDL type MidiSynth.

/** @interface Project
 * See also the corresponding C++ stub class ProjectHandle. */
/// See also the corresponding IDL class Project.
class ProjectHandle : public virtual ContainerHandle
{
  static ProjectHandle                   __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ProjectHandle () override;
  template<class RemoteHandle>
  static ProjectHandle          down_cast (RemoteHandle smh) { return smh == NULL ? ProjectHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ProjectHandle ();
  void                          change_name         (const std::string &name); 	///< See Project::change_name()
  Error                         play                (); 	///< See Project::play()
  Error                         activate            (); 	///< See Project::activate()
  bool                          can_play            (); 	///< See Project::can_play()
  bool                          is_playing          (); 	///< See Project::is_playing()
  bool                          is_active           (); 	///< See Project::is_active()
  void                          start_playback      (); 	///< See Project::start_playback()
  void                          stop_playback       (); 	///< See Project::stop_playback()
  void                          deactivate          (); 	///< See Project::deactivate()
  void                          stop                (); 	///< See Project::stop()
  void                          auto_deactivate     (int msec_delay); 	///< See Project::auto_deactivate()
  int                           undo_depth          (); 	///< See Project::undo_depth()
  void                          undo                (); 	///< See Project::undo()
  int                           redo_depth          (); 	///< See Project::redo_depth()
  void                          redo                (); 	///< See Project::redo()
  void                          clear_undo          (); 	///< See Project::clear_undo()
  void                          clean_dirty         (); 	///< See Project::clean_dirty()
  bool                          is_dirty            (); 	///< See Project::is_dirty()
  void                          inject_midi_control (int midi_channel,
                                                     int midi_control,
                                                     double control_value); 	///< See Project::inject_midi_control()
  Error                         import_midi_file    (const std::string &file_name); 	///< See Project::import_midi_file()
  Error                         restore_from_file   (const std::string &file_name); 	///< See Project::restore_from_file()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContainerHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ProjectHandle ProjectH; ///< Convenience alias for the IDL type Project.

/** @interface PcmWriter
 * See also the corresponding C++ stub class PcmWriterHandle. */
/// See also the corresponding IDL class PcmWriter.
class PcmWriterHandle : public virtual ItemHandle
{
  static PcmWriterHandle                 __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~PcmWriterHandle () override;
  template<class RemoteHandle>
  static PcmWriterHandle        down_cast (RemoteHandle smh) { return smh == NULL ? PcmWriterHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      PcmWriterHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef PcmWriterHandle PcmWriterH; ///< Convenience alias for the IDL type PcmWriter.

/** @interface Server
 * See also the corresponding C++ stub class ServerHandle. */
/// See also the corresponding IDL class Server.
class ServerHandle : public virtual ObjectHandle
{
  typedef Rapicorn::Aida::Connector<ServerHandle, void (const ClnT_UserMessage &umsg)> __Aida_Signal__user_message;
  size_t __aida_connect__user_message (size_t, const std::function<void (const ClnT_UserMessage &umsg)>&);
  static ServerHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ServerHandle () override;
  template<class RemoteHandle>
  static ServerHandle           down_cast (RemoteHandle smh) { return smh == NULL ? ServerHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ServerHandle ();
  __Aida_Signal__user_message   sig_user_message () { return __Aida_Signal__user_message (*this, &ServerHandle::__aida_connect__user_message); }
  TestObjectHandle              get_test_object           (); 	///< See Server::get_test_object()
  ObjectHandle                  from_proxy                (int64_t proxyid); 	///< See Server::from_proxy()
  std::string                   get_mp3_version           (); 	///< See Server::get_mp3_version()
  std::string                   get_vorbis_version        (); 	///< See Server::get_vorbis_version()
  std::string                   get_ladspa_path           (); 	///< See Server::get_ladspa_path()
  std::string                   get_plugin_path           (); 	///< See Server::get_plugin_path()
  std::string                   get_script_path           (); 	///< See Server::get_script_path()
  std::string                   get_instrument_path       (); 	///< See Server::get_instrument_path()
  std::string                   get_sample_path           (); 	///< See Server::get_sample_path()
  std::string                   get_effect_path           (); 	///< See Server::get_effect_path()
  std::string                   get_demo_path             (); 	///< See Server::get_demo_path()
  std::string                   get_custom_instrument_dir (); 	///< See Server::get_custom_instrument_dir()
  std::string                   get_custom_effect_dir     (); 	///< See Server::get_custom_effect_dir()
  std::string                   get_version               (); 	///< See Server::get_version()
  void                          save_preferences          (); 	///< See Server::save_preferences()
  void                          register_ladspa_plugins   (); 	///< See Server::register_ladspa_plugins()
  void                          register_core_plugins     (); 	///< See Server::register_core_plugins()
  void                          register_scripts          (); 	///< See Server::register_scripts()
  bool                          preferences_locked        (); 	///< See Server::preferences_locked()
  int                           n_scripts                 (); 	///< See Server::n_scripts()
  bool                          can_load                  (const std::string &file_name); 	///< See Server::can_load()
  void                          start_recording           (const std::string &wave_file,
                                                           double n_seconds); 	///< See Server::start_recording()
  ProjectHandle                 create_project            (const std::string &project_name); 	///< See Server::create_project()
  void                          destroy_project           (ProjectHandle &project); 	///< See Server::destroy_project()
  ClnT_AuxDataSeq               list_module_types         (); 	///< See Server::list_module_types()
  ClnT_AuxData                  find_module_type          (const std::string &module_type); 	///< See Server::find_module_type()
  ClnT_Icon                     module_type_icon          (const std::string &module_type); 	///< See Server::module_type_icon()
  ClnT_SampleFileInfo           sample_file_info          (const std::string &file_name); 	///< See Server::sample_file_info()
  ClnT_NoteDescription          note_describe             (MusicalTuning musical_tuning,
                                                           int note,
                                                           int fine_tune); 	///< See Server::note_describe()
  ClnT_NoteDescription          note_describe_from_freq   (MusicalTuning musical_tuning,
                                                           double freq); 	///< See Server::note_describe_from_freq()
  ClnT_NoteDescription          note_construct            (MusicalTuning musical_tuning,
                                                           int semitone,
                                                           int octave,
                                                           int fine_tune); 	///< See Server::note_construct()
  ClnT_NoteDescription          note_from_string          (MusicalTuning musical_tuning,
                                                           const std::string &name); 	///< See Server::note_from_string()
  int                           note_from_freq            (MusicalTuning musical_tuning,
                                                           double frequency); 	///< See Server::note_from_freq()
  double                        note_to_freq              (MusicalTuning musical_tuning,
                                                           int note,
                                                           int fine_tune); 	///< See Server::note_to_freq()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ObjectHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ServerHandle ServerH; ///< Convenience alias for the IDL type Server.
} // Bse

// C++ Aliases
#ifndef __BSE_IDL_ALIASES__
#define __BSE_IDL_ALIASES__    1
#endif
#if     __BSE_IDL_ALIASES__ == 1
namespace Bse {
typedef ClnT_StringSeq StringSeq;
typedef ClnT_PixelSeq PixelSeq;
typedef ClnT_Icon Icon;
typedef ClnT_AuxData AuxData;
typedef ClnT_AuxDataSeq AuxDataSeq;
typedef ClnT_UserMessage UserMessage;
typedef ClnT_SongTiming SongTiming;
typedef ClnT_NoteDescription NoteDescription;
typedef ClnT_PartNote PartNote;
typedef ClnT_PartNoteSeq PartNoteSeq;
typedef ClnT_PartControl PartControl;
typedef ClnT_PartControlSeq PartControlSeq;
typedef ClnT_PartSeq PartSeq;
typedef ClnT_PartLink PartLink;
typedef ClnT_PartLinkSeq PartLinkSeq;
typedef ClnT_TrackPart TrackPart;
typedef ClnT_TrackPartSeq TrackPartSeq;
typedef ClnT_SampleFileInfo SampleFileInfo;
} // Bse
#endif // __BSE_IDL_ALIASES__

#endif /* __CLNT__BSE_IDL */
