
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsecontainer.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsecontainer.hh>
#include "bsecxxplugin.hh"
#include "bsebuiltin_externs.cc"


#line 11 "bsecontainer.proc"


/* --- list-children --- */
static void
list_children_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 13 "bsecontainer.proc"
 {
#line 15 "bsecontainer.proc"
  *(in_pspecs++) = bse_param_spec_object ("container", NULL, NULL, BSE_TYPE_CONTAINER, SFI_PARAM_STANDARD);
  *(out_pspecs++) = bse_param_spec_boxed ("item_list", NULL, NULL, BSE_TYPE_IT3M_SEQ, SFI_PARAM_STANDARD);
#line 17 "bsecontainer.proc"
}  }
static Bse::Error
#line 17 "bsecontainer.proc"
list_children_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 20 "bsecontainer.proc"
{
#line 21 "bsecontainer.proc"
  
  BseContainer *container = (BseContainer*) bse_value_get_object (in_values++);

#line 24 "bsecontainer.proc"
  
  if (!BSE_IS_CONTAINER (container))
    return Bse::Error::PROC_PARAM_INVAL;

#line 28 "bsecontainer.proc"
  
  bse_value_take_boxed (out_values++, bse_container_list_children (container));

  return Bse::Error::NONE;
}

/* --- get-item --- */
static void
get_item_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 34 "bsecontainer.proc"
 {
#line 36 "bsecontainer.proc"
  *(in_pspecs++) = bse_param_spec_object ("container", NULL, NULL, BSE_TYPE_CONTAINER, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("item_type", NULL, "Type of the item to retrieve",
			    NULL, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("seq_id", NULL, "Sequential ID",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("item", NULL, "The item with seqid as requested", BSE_TYPE_ITEM, SFI_PARAM_STANDARD);
#line 42 "bsecontainer.proc"
}  }
static Bse::Error
#line 42 "bsecontainer.proc"
get_item_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 45 "bsecontainer.proc"
{
#line 46 "bsecontainer.proc"
  
  BseContainer *container = (BseContainer*) bse_value_get_object (in_values++);
  const char *type_name   = sfi_value_get_string (in_values++);
  guint seqid             = sfi_value_get_int (in_values++);
  GType type = type_name ? g_type_from_name (type_name) : 0;

#line 52 "bsecontainer.proc"
  
  if (!BSE_IS_CONTAINER (container) || !g_type_is_a (type, BSE_TYPE_ITEM))
    return Bse::Error::PROC_PARAM_INVAL;

#line 56 "bsecontainer.proc"
  
  bse_value_set_object (out_values++, bse_container_get_item (container, type, seqid));

  return Bse::Error::NONE;
}

/* --- Export to BSE --- */
static void
__enode_list_children__fill_strings (BseExportStrings *es)
{
  es->blurb = _("Retrieve all immediate children of a container");
  es->file = "/opt/src/beast/bse/bsecontainer.proc";
  es->line = 14;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_list_children = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseContainer+list-children", 
    NULL,
    "/Methods/BseContainer/General/List Children",
    NULL,
    __enode_list_children__fill_strings,
  },
  0, list_children_setup, list_children_exec, 
};
static void
__enode_get_item__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve a containers immediate child from it's sequential id.";
  es->file = "/opt/src/beast/bse/bsecontainer.proc";
  es->line = 35;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_item = {
  { (BseExportNode*) &__enode_list_children, BSE_EXPORT_NODE_PROC,
    "BseContainer+get-item", 
    NULL,
    "/Methods/BseContainer/General/Get Item",
    NULL,
    __enode_get_item__fill_strings,
  },
  0, get_item_setup, get_item_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsecontainer_genprc_cc (void)
{
  return (BseExportNode*) &__enode_get_item;
}

/*
 * Generated data ends here
 */
