
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsewaverepo.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsewaverepo.hh>
#include <bse/bseloader.hh>
#include <bse/bsewave.hh>
#include "bsecxxplugin.hh"
#include "bsebuiltin_externs.cc"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>


#line 16 "bsewaverepo.proc"

static Bse::Error
load_file (BseWaveRepo *wrepo,
	   const gchar *file_name,
           BseWave    **wave_p)
{
  gchar *fname = g_path_get_basename (file_name);
  BseWave *wave = (BseWave*) bse_object_new (BSE_TYPE_WAVE, "uname", fname, NULL);
  g_free (fname);
  Bse::Error error = bse_wave_load_wave_file (wave, file_name, NULL, NULL, NULL, TRUE);
  if (wave->n_wchunks)
    {
      bse_container_add_item (BSE_CONTAINER (wrepo), BSE_ITEM (wave));
      *wave_p = wave;
      error = Bse::Error::NONE;
    }
  else
    {
      if (error == 0)
        error = Bse::Error::WAVE_NOT_FOUND;
      *wave_p = NULL;
    }
  g_object_unref (wave);
  return error;
}


#line 43 "bsewaverepo.proc"

#line 46 "bsewaverepo.proc"


/* --- load-file --- */
static void
load_file_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 48 "bsewaverepo.proc"
 {
#line 50 "bsewaverepo.proc"
  *(in_pspecs++)    = bse_param_spec_object ("wave_repo", "Wave Repo", NULL,
				 BSE_TYPE_WAVE_REPO, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_string ("file_name", "File Name", "The file to import waves from",
			    NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, Bse::Error::NONE,
				SFI_PARAM_STANDARD);
}
#line 58 "bsewaverepo.proc"
 }
static Bse::Error
#line 58 "bsewaverepo.proc"
load_file_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 61 "bsewaverepo.proc"
{
#line 62 "bsewaverepo.proc"
  
  BseWaveRepo *self = (BseWaveRepo*) bse_value_get_object (in_values++);
  const char *file_name = sfi_value_get_string (in_values++);
  BseUndoStack *ustack;
  Bse::Error error;
  BseWave *wave;

#line 69 "bsewaverepo.proc"
  
  if (!BSE_IS_WAVE_REPO (self) || !file_name)
    return Bse::Error::PROC_PARAM_INVAL;

  ustack = bse_item_undo_open (self, "load-wave");
  error = load_file (self, file_name, &wave);
  if (wave)
    bse_item_push_undo_proc (self, "remove-wave", wave);
  bse_item_undo_close (ustack);

#line 79 "bsewaverepo.proc"
  
  g_value_set_enum (out_values++, int (error));

  return Bse::Error::NONE;
}

/* --- remove-wave --- */
static void
remove_wave_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 85 "bsewaverepo.proc"
 {
#line 87 "bsewaverepo.proc"
  *(in_pspecs++)    = bse_param_spec_object ("wave_repo", "Wave Repo", NULL,
				 BSE_TYPE_WAVE_REPO, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("wave", "Wave", NULL,
				 BSE_TYPE_WAVE, SFI_PARAM_STANDARD);
#line 91 "bsewaverepo.proc"
}  }
static Bse::Error
#line 91 "bsewaverepo.proc"
remove_wave_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 94 "bsewaverepo.proc"
{
#line 95 "bsewaverepo.proc"
  
  BseWaveRepo *self = (BseWaveRepo*) bse_value_get_object (in_values++);
  BseItem *child    = (BseItem*) bse_value_get_object (in_values++);
  BseUndoStack *ustack;

#line 100 "bsewaverepo.proc"
  
  if (!BSE_IS_WAVE_REPO (self) || !BSE_IS_WAVE (child) ||
      child->parent != BSE_ITEM (self))
    return Bse::Error::PROC_PARAM_INVAL;

#line 105 "bsewaverepo.proc"
  
  ustack = bse_item_undo_open (self, "remove-wave %s", bse_object_debug_name (child));
#line 107 "bsewaverepo.proc"
  
  bse_container_uncross_undoable (BSE_CONTAINER (self), child);
#line 109 "bsewaverepo.proc"
  
  bse_item_push_redo_proc (self, "remove-wave", child);
#line 111 "bsewaverepo.proc"
  
  bse_container_remove_backedup (BSE_CONTAINER (self), child, ustack);
#line 113 "bsewaverepo.proc"
  
  bse_item_undo_close (ustack);

  return Bse::Error::NONE;
}

/* --- Export to BSE --- */
static void
__enode_load_file__fill_strings (BseExportStrings *es)
{
  es->blurb = "Load wave from file";
  es->file = "/opt/src/beast/bse/bsewaverepo.proc";
  es->line = 49;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_load_file = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseWaveRepo+load-file", 
    NULL,
    "/Methods/BseWaveRepo/General/Load File",
    NULL,
    __enode_load_file__fill_strings,
  },
  0, load_file_setup, load_file_exec, 
};
static void
__enode_remove_wave__fill_strings (BseExportStrings *es)
{
  es->blurb = "Remove a wave from repository";
  es->file = "/opt/src/beast/bse/bsewaverepo.proc";
  es->line = 86;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_remove_wave = {
  { (BseExportNode*) &__enode_load_file, BSE_EXPORT_NODE_PROC,
    "BseWaveRepo+remove-wave", 
    NULL,
    "/Methods/BseWaveRepo/General/Remove Wave",
    NULL,
    __enode_remove_wave__fill_strings,
  },
  0, remove_wave_setup, remove_wave_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsewaverepo_genprc_cc (void)
{
  return (BseExportNode*) &__enode_remove_wave;
}

/*
 * Generated data ends here
 */
